// 2003-12-13 programmeerimisvistluse algajate 1. lesande lahendus
// lesanne: KOLMNURGAD
// Autor: Mihkel Kree
// Testitud: GCC 3.2 / MinGW

#include <fstream>
using namespace std;

typedef struct punkt{
  int x, y;
}punkt;

punkt andmed[1+100];
int n;

// Jrgnevates muutujates hoiame vhima seni teadaoleva pindala nelja-
// kordset ruutu ning vastavaid tippe.
// lesandes antud piirangute phjal on parim alati viksem kui 10^14.
long long parim=100000000000000;
int parimi, parimj, parimk;

// Kontrollib, kas punktid i,j,k moodustavad tisnurkse kolmnurga
// tisnurgaga tipus i.
bool ontaisnurkne(punkt i, punkt j, punkt k){
  // Kontrollime vektorite i-j ja i-k skalaarkorutist.
  int sk=(j.x-i.x)*(k.x-i.x)+(j.y-i.y)*(k.y-i.y);
  // Vektorid on risti, kui skalaarkorrutis on null.
  return (sk==0);
}

// Kuna lesandes ei ksita pindala, siis piisab vhima pindalaga
// kolmurga leidmiseks pindala neljakordse ruudu arvutamisest
// (ruuduga vldime juurimist, neljakordsega murdarve).
long long arvuta(punkt i, punkt j, punkt k){
  // Arvutame kaatetite pikkuste ruudud.
  long long kylga=(i.x-j.x)*(i.x-j.x)+(i.y-j.y)*(i.y-j.y);
  long long kylgb=(i.x-k.x)*(i.x-k.x)+(i.y-k.y)*(i.y-k.y);
  // Kolmnurga pindala valemist...
  return kylga*kylgb;
}

int main(){
  // Loeme sisse punktid.
  ifstream sis("KOLM.SIS");
  sis >> n;
  for (int i=1; i<=n; i++){
    sis >> andmed[i].x >> andmed[i].y;
  }

  // Genereerime punktikolmikud {i,j,k} ning kontrollime, kas
  // tisnurk paikneb tipus i. Kui jah, siis arvutame pindala
  // ning vrdleme seda parima teadaolevaga.
  for (int i=1; i<=n; i++)
    for (int j=1; j<=n; j++) if (i!=j)
      for (int k=1; k<=n; k++) if ( (k!=i) && (k!=j) )
        if (ontaisnurkne(andmed[i],andmed[j],andmed[k])){
          long long p=arvuta(andmed[i],andmed[j],andmed[k]);
          if (p<parim){
            parim=p;
            parimi=i;
            parimj=j;
            parimk=k;
          }
        }

  // Vljastame tulemuse.
  ofstream val("KOLM.VAL");
  val << parimi << " " << parimj << " " << parimk << endl;

  return 0;
}
