{ 2003-12-13 programmeerimisvistluse algajate 1. lesande lahendus         }
{ lesanne: KOLMNURGAD                                                      }
{ Autor: Ahto Truu                                                          }
{ Testitud: FPC 1.0.6 / Win32, TPC 6.0                                      }

const
   sisf = 'KOLM.SIS';                                    { sisendfaili nimi }
   valf = 'KOLM.VAL';                                   { vljundfaili nimi }
   maxn = 100;                                   { maksimaalne punktide arv }

type
   punkt = record                                           { punkti andmed }
      x, y : longint;                                        { koordinaadid }
   end;

var
   n : integer;                                              { punktide arv }
   p : array [1..maxn] of punkt;                                  { punktid }

{ kontrollib, kas p[i1], p[i2], p[i3] moodustavad tisnurkse kolmnurga      }
{ kui jah, s := selle pindala                                               }
function taisnurk(i1, i2, i3 : integer; var s : real) : boolean;
var k1, k2, k3, k : longint;
begin
   { leiame kljepikkuste ruudud }
   k1 := sqr(p[i2].x - p[i3].x) + sqr(p[i2].y - p[i3].y);
   k2 := sqr(p[i3].x - p[i1].x) + sqr(p[i3].y - p[i1].y);
   k3 := sqr(p[i1].x - p[i2].x) + sqr(p[i1].y - p[i2].y);
   { jrjestame nii, et k1 oleks maksimaalne }
   if k1 < k2 then begin
      k := k1; k1 := k2; k2 := k;
   end;
   if k1 < k3 then begin
      k := k1; k1 := k3; k3 := k;
   end;
   { maksimaalne peab olema kahe lejnu summa }
   if k1 = k2 + k3 then begin
      { siis on tisnurkne kolmnurk, tagastame pindala }
      s := sqrt(k2) * sqrt(k3) / 2;
      taisnurk := true;
   end else begin
      { muidu pole tisnurkne }
      taisnurk := false;
   end;
end;

var
   f : text;
   i : integer;
   i1, i2, i3 : integer;                          { jooksva kolmnurga tipud }
   s : real;                                    { jooksva kolmnurga pindala }
   ii1, ii2, ii3 : integer;                        { leitud kolmnurga tipud }
   ss : real;                                    { leitud kolmnurga pindala }
begin
   { loeme sisendandmed }
   assign(f, sisf); reset(f);
   readln(f, n);
   for i := 1 to n do
      readln(f, p[i].x, p[i].y);
   close(f);

   { lahendame lesande }
   ss := -1;
   { vaatleme kiki punktikolmikuid }
   for i1 := 1 to n do
      for i2 := i1 + 1 to n do
         for i3 := i2 + 1 to n do
            if taisnurk(i1, i2, i3, s) then
               if (ss < 0) or (s < ss) then begin
                  ii1 := i1; ii2 := i2; ii3 := i3; ss := s;
               end;

   { vljastame vastuse }
   assign(f, valf); rewrite(f);
   writeln(f, ii1, ' ', ii2, ' ', ii3);
   close(f);
end.
