{ 2003-12-13 programmeerimisvistluse edasijudnute 1. lesande lahendus    }
{ lesanne: RISTKLIKUD                                                     }
{ Autor: Ahto Truu                                                          }
{ Testitud: FPC 1.0.6 / Win32, TPC 6.0                                      }

{ Kontrollib kiki punktinelikuid ja jb suuremates testides ajahtta.     }

const
   sisf = 'RIST.SIS';                                    { sisendfaili nimi }
   valf = 'RIST.VAL';                                   { vljundfaili nimi }
   maxn = 100;                                   { maksimaalne punktide arv }

type
   punkt = record                                           { punkti andmed }
      x, y : longint;                                        { koordinaadid }
   end;

var
   n : integer;                                              { punktide arv }
   p : array [1..maxn] of punkt;                                  { punktid }

{ kontrollib, kas p[i1], p[i2], p[i3], p[i4] moodustavad ristkliku         }
{ kui jah, s := ristkliku pindala                                          }
function ristkyl(i1, i2, i3, i4 : integer; var s : longint) : boolean;
var k12, k23, k34, k41, k13, k24 : longint;
begin
   { kljepikkuste ruudud }
   k12 := sqr(p[i1].x - p[i2].x) + sqr(p[i1].y - p[i2].y);
   k23 := sqr(p[i2].x - p[i3].x) + sqr(p[i2].y - p[i3].y);
   k34 := sqr(p[i3].x - p[i4].x) + sqr(p[i3].y - p[i4].y);
   k41 := sqr(p[i4].x - p[i1].x) + sqr(p[i4].y - p[i1].y);
   { diagonaalide ruudud }
   k13 := sqr(p[i1].x - p[i3].x) + sqr(p[i1].y - p[i3].y);
   k24 := sqr(p[i2].x - p[i4].x) + sqr(p[i2].y - p[i4].y);
   { vastaskljed vrdsed, diagonaalid vrdsed -> ristklik }
   if (k12 = k34) and (k23 = k41) and (k13 = k24) then
      if (k12 < k13) and (k23 < k13) then begin
         s := round(sqrt(k12) * sqrt(k23));
         ristkyl := true;
         exit;
      end;
   ristkyl := false;
end;

var
   f : text;
   i : integer;
   i1, i2, i3, i4 : integer;                     { jooksva ristkliku tipud }
   s : longint;                                { jooksva ristkliku pindala }
   ii1, ii2, ii3, ii4 : integer;                  { leitud ristkliku tipud }
   ss : longint;                                { leitud ristkliku pindala }
begin
   { loeme sisendandmed }
   assign(f, sisf); reset(f);
   readln(f, n);
   for i := 1 to n do
      readln(f, p[i].x, p[i].y);
   close(f);

   { lahendame lesande }
   ss := -1;
   { vaatleme kiki punktinelikuid }
   for i1 := 1 to n do
      for i2 := i1 + 1 to n do
         for i3 := i2 + 1 to n do
            for i4 := i3 + 1 to n do
               if ristkyl(i1, i2, i3, i4, s) or
                  ristkyl(i1, i2, i4, i3, s) or
                  ristkyl(i1, i3, i2, i4, s) then
                  if (ss < 0) or (s < ss) then begin
                     ii1 := i1; ii2 := i2; ii3 := i3; ii4 := i4; ss := s;
                  end;

   { vljastame vastuse }
   assign(f, valf); rewrite(f);
   writeln(f, ii1, ' ', ii2, ' ', ii3, ' ', ii4);
   close(f);
end.
