// 2003-12-13 programmeerimisvistluse algajate 1. lesande lahendus
// lesanne: RISTKLIKUD
// Autor: Mihkel Kree
// Testitud: GCC 3.2 / MinGW

#include <fstream>
using namespace std;

typedef struct punkt{
  int x, y;
}punkt;

punkt andmed[1+100];
int n;

// Pole tingimata vaja pindlade vrdlemisks pindalasid vlja arvutada, piisab
// pindalade ruutude vrdlemisest. Theldame, et pindala ruut on < 10^14.
long long bpindruut=100000000000000;
int bi, bj, bk, bl; // Hoiame parima ristkliku tippe

// Kontrollib, kas vektorid v1 ja v2 on risti.
bool onristi(punkt v1, punkt v2){
  return (v1.x*v2.x + v1.y*v2.y==0);
}

int main(){
  ifstream sis("RIST.SIS");
  sis >> n;
  for (int i=1; i<=n; i++)
    sis >> andmed[i].x >> andmed[i].y;

  // Moodustame punktikolmikud i,j,k; ning vaatame, kas ligud ij ja ik
  // on risti. Ristioleku kontrollimiseks on mitu vimalust: 
  // kastuda Pythagorase teoreemi vi kontrollida, kas kljevektorite
  // skalaarkorrutis vrdub nulliga.
  for (int i=1; i<=n; i++)
    for (int j=1; j<=n; j++) if (j!=i){
      punkt vektorij;
      vektorij.x=andmed[j].x-andmed[i].x;
      vektorij.y=andmed[j].y-andmed[i].y;
      for (int k=1; k<=n; k++) if ( (k!=i) && (k!=j) ){
        punkt vektorik;
        vektorik.x=andmed[k].x-andmed[i].x;
        vektorik.y=andmed[k].y-andmed[i].y;

        if (onristi(vektorij,vektorik)){
          // Nd teame, et vekorid ij ja ik on omavahel risti.
          // Kui otsitav nelinurk leidub, siis peab tema pindala
          // vrduma vektorite ij ja ik pikkuste korrutisega.
          // Antud juhul leiame pindala ruudu (ei viitsi juurima hakata).
          long long pind2=(vektorij.x*vektorij.x + vektorij.y*vektorij.y)*
            (vektorik.x*vektorik.x + vektorik.y*vektorik.y);

          if (pind2>=bpindruut) continue;

          // Teame ka, et neljanda punkti koordinaadid leiame, kui liidame
          // punkti k koordinaatidele vektori ij.
          punkt neljaspunkt;
          neljaspunkt.x=andmed[k].x + vektorij.x;
          neljaspunkt.y=andmed[k].y + vektorij.y;

          for (int l=1; l<=n; l++) if (andmed[l].x==neljaspunkt.x)
            if (andmed[l].y==neljaspunkt.y){
              // olemegi leidnud nelinurga
              bpindruut=pind2;
              bi=i; bj=j; bk=k; bl=l;
            }
        }
      }
    }

  ofstream val("RIST.VAL");
  val << bi << " " << bj << " " << bk << " " << bl << endl;

  return 0;
}
