/* 2003-12-13 programmeerimisvistluse algajate 3. lesande lahendus       */
/* lesanne: SILBITAMINE                                                   */
/* Autor: Heno Ivanov                                                      */
/* Testitud: GCC 3.2 / MinGW                                               */

#include <stdio.h>
#include <string.h>

/* Kontrollib, kas c on tishlik */
int TH(char c) {
	return (c=='a') || (c=='e') ||
	       (c=='i') || (c=='o') ||
	       (c=='u') || (c=='y');
}

/* Kontrollib, kas c on kaashlik */
int KH(char c) {
	return (c>='a') && (c<='z') && !TH(c);
}

/* Kontrollib, kas puhvri positsioonis idx saab rakendada 1. vi 2. reeglit */
int r12(char *buf, int idx, int len) {

	if (idx + 3 > len)
		return 0;

	if (KH(buf[idx+1]) && TH(buf[idx+2])) {
		while ((idx > 0) && KH(buf[idx]))
			--idx;
		return TH(buf[idx]);
	}

	return 0;
}

/* Kontrollib, kas puhvri positsioonis idx saab rakendada 4. reeglit */
int r4(char *buf, int idx, int len) {

	if ((idx==0) || (idx + 2 > len))
		return 0;

	return TH(buf[idx-1]) && TH(buf[idx]) && TH(buf[idx+1]);
}

void silbita(char *buf, char *obuf) {
	int l;
	int i;
	int rf4 = -1;
	l = strlen(buf);
	for (i=0;i<l;i++) {
		*obuf++ = buf[i];
		if (r12(buf,i,l)) {
			*obuf++ = '-';
		}

		/* kontroll, et 4. reeglit ei rakendataks juba
		 * lbivaadatud snaosa peale
		 */
		if (r4(buf,i,l)) {
			if (rf4+1!=i) {
				*obuf++ = '-';
				rf4=i;
			}
		}
	}
	*obuf++ = '\0';
}

int main() {
	char buf[1000];
	char obuf[1000];
	FILE *fi, *fo;
	int i,n;

	if ((fi = fopen("silba.sis","r")) == NULL) return 1;
	fo = fopen("silba.val","w");
	fscanf(fi,"%d",&n);

	for (i=0;i<n;i++) {
		fscanf(fi,"%s",buf);	
		silbita(buf,obuf);
		fprintf(fo,"%s\n",obuf);
	}

	fclose(fi);
	fclose(fo);
	return 0;
}
